#! /bin/jsh
#
# Copyright 2013-2014 Yuichiro Moriguchi
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
this='$this'
c='$c'
cat << EOF

${3}.prototype.${2}_step = function($this, $c) {
	switch(this.__state) {
EOF
print_states $1 $4
cat << EOF
	}
	return 0;
}

${3}.prototype.${2}_accepted = function($this) {
EOF
print_accepts $1
echo '}'
echo
echo "${3}.prototype.${2}_gettoken = function($this, __b__) {"
echo '		var $$ = __b__;'
echo
echo '		switch(this.__state) {'
print_token $1
echo '		default:  return null;'
echo '		}'
echo '	}'
echo
echo "${3}.prototype.${2}_isdead = function($this) {"
print_nfadead $1
echo '	}'
